/*-----------------------------------------------------------------------*/
/* filename -       thandler.hpp                                         */
/*                                                                       */
/* function(s)                                                           */
/*                  declarations for the THandler class                  */
/*                                                                       */
/* author -         Michael Newton                                       */
/*                                                                       */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/*                                                                       */
/*    THANDLER.HPP                                                       */
/*                                                                       */
/*    THandler Version 1.01                                              */
/*    Copyright (C) 1992, 1993 Michael Newton                            */
/*    All Rights Reserved.                                               */
/*                                                                       */
/*-----------------------------------------------------------------------*/




#if !defined __THANDLER_HPP
#define __THANDLER_HPP


#include <tv.h>


typedef void interrupt (far *fptr)(...);
typedef unsigned char       byte;
typedef unsigned int        word;
typedef unsigned int far    *fpword;
typedef void                *pvoid;
typedef void far            *fpvoid;



#define MAXERRWIDTH 52

const ignoreOK   = 0x2000;
const retryOK    = 0x1000;
const failOK     = 0x0800;
const driveMask  = 0x00FF;
const bit07      = 0x0080;


class THandler
{
   public:
      THandler(Boolean isSound = True);
      ~THandler();
      void suspend();
      void resume();
      void setSound(Boolean isSound);
      Boolean getSound();
   private:
      static void interrupt (far *oldInt24)(...);
      static void far newInt24(word ax, word di, fpword bpsi);
};



#endif                            // End of __THANDLER_HPP
